import 'package:flutter/material.dart';
import 'package:mobile_pos/mobile_pos_sdk.dart';

class RavenPayExampleApp extends StatefulWidget {
  const RavenPayExampleApp({super.key});

  @override
  State<RavenPayExampleApp> createState() => _RavenPayExampleAppState();
}

class _RavenPayExampleAppState extends State<RavenPayExampleApp> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        body: Center(
            child: ElevatedButton(
                onPressed: () async {
                  await RavenBankBoxPlugin.launch(
                    // amount: 10,
                    context,
                    config: BankBoxConfig(
                      logo: Container(
                        height: 32,
                        width: 32,
                        decoration: const BoxDecoration(
                            shape: BoxShape.circle, color: Color(0xffEA872D)),
                        child: Padding(
                          padding: const EdgeInsets.all(12),
                          child: Image.asset('assets/logo.png'),
                        ),
                      ),
                      onClose: () {
                        //user taps close button
                        Navigator.pop(context);
                      },
                      showTerminals: true,
                      enableBalanceCheck: true,
                      enableSuccessSound: true,
                      showLabel: true,
                      theme: const MobilePOSTheme(
                          darkModeFG: Color(0xff141414),
                          lightModeFG: Colors.white,
                          bankBoxThemeMode: BankBoxThemeMode.dark,
                          headerTextColor: Color(0xFF755AE2),
                          primaryColor: Color(0xFF755AE2),
                          onPrimary: Colors.white,
                          secondaryColor: Color(0xFFEA872D)),
                      environment: BankBoxEnvironment.production,
                      appInfo: AppInfo(
                          category: Category.partner,
                          appName: 'BESTSTAR',
                          appId: '903834f27ff7b60a5018f9d38c41c5d4',
                          appEmail: 'uchennannodim@beststarmfb.com'),
                      customerInfo: CustomerInfo(
                        lastName: 'Champ',
                        firstName: 'Champ',
                        bvn: '23234137687',
                        email: 'dechosenuchenna@gmail.com',
                        phone: '08166106863',
                      ),
                      onSuccess: (data) {
                        //TODO: handle success cases
                      },
                      onError: (error) {
                        //TODO: handle error cases
                      },
                    ),
                  );
                },
                child: const Text("Start Payment"))));
  }
}
