import 'package:mobile_pos/src/helpers/global_variables.dart';

class URLS {
  static String cardProcessingUrl(String category) =>
      category.toUpperCase().contains("PARTNER")
          ? (pluginConfig.isStaging
              ? 'https://partners.getravenpos.com/pdon/card_processing'
              : 'https://partners.getravenbank.com/pdon/card_processing')
          : (pluginConfig.isStaging
              ? "https://postest.getravenpos.com/pdon/card_processing"
              : "https://posapi.getravenbank.com/v1/pdon/card_processing");

  static String getInjectUrl() => (pluginConfig.isStaging)
      ? "http://terminals.getravenpos.com/pdon/update_card_injection"
      : "https://terminals.getravenbank.com/pdon/update_card_injection";

  static String getTerminalUrl() => (pluginConfig.isStaging)
      ? "http://terminals.getravenpos.com/pdon/get_business_terminal"
      : "https://terminals.getravenbank.com/pdon/get_business_terminal";

  static String getWhatsappReceiptUrl(String category) =>
      category.toUpperCase().contains("PARTNER")
          ? (pluginConfig.isStaging
              ? "https://partners.getravenpos.com/pdon/whatsapp_receipt"
              : "https://partners.getravenbank.com/pdon/whatsapp_receipt")
          : (pluginConfig.isStaging
              ? "https://postest.getravenpos.com/pdon/whatsapp_receipt"
              : "https://posapi.getravenbank.com/v1/pdon/whatsapp_receipt");

  static String getEmailReceiptUrl(String category) =>
      category.toUpperCase().contains("PARTNER")
          ? (pluginConfig.isStaging
              ? "https://partners.getravenpos.com/pdon/share_receipt"
              : "https://partners.getravenbank.com/pdon/share_receipt")
          : (pluginConfig.isStaging
              ? "https://postest.getravenpos.com/pdon/share_receipt"
              : "https://posapi.getravenbank.com/v1/pdon/share_receipt");

  static String getQrCodeReceiptUrl(String category, String rrn) => category
          .toUpperCase()
          .contains("PARTNER")
      ? (pluginConfig.isStaging
          ? "https://partners.getravenpos.com/pdon/get/qrcode_receipt?rrn=$rrn"
          : "https://partners.getravenbank.com/pdon/get/qrcode_receipt?rrn=$rrn")
      : (pluginConfig.isStaging
          ? "https://postest.getravenpos.com/pdon/get/qrcode_receipt?rrn=$rrn"
          : "https://posapi.getravenbank.com/v1/pdon/get/qrcode_receipt?rrn=$rrn");
}
