class BluetoothModel {
  String title;
  String serialNo;
  int cardInjection;
  String address;
  String deviceLabel;
  String clearMasterKey;
  String clearSessionKey;
  String clearPinKey;
  String port;
  String businessName;
  String ip;
  String terminalId;
  String mPosSerial;
  String sn;
  String mid;
  int tapStatus;
  double terminalTapLimit;
  String category;
  BluetoothModel(
      {required this.title,
      required this.serialNo,
      required this.deviceLabel,
      required this.mPosSerial,
      required this.businessName,
      required this.cardInjection,
      required this.address,
      required this.clearMasterKey,
      required this.clearPinKey,
      required this.terminalId,
      required this.clearSessionKey,
      required this.ip,
      required this.mid,
      required this.sn,
      required this.port,
      required this.terminalTapLimit,
      required this.tapStatus,
      required this.category});

  factory BluetoothModel.fromJson(Map<String, dynamic> json) => BluetoothModel(
        title: json["title"],
        serialNo: json["serialNo"],
        cardInjection: json["card_injection"],
        address: json["address"],
        deviceLabel: json["device_label"] ?? "",
        clearMasterKey: json['master_key'] ?? "",
        clearPinKey: json['pin_key'] ?? "",
        mPosSerial: json['mpos_serial'] ?? "",
        clearSessionKey: json['session_key'] ?? "",
        ip: json['ip'] ?? "",
        port: json['port'] ?? "",
        sn: json['SN'] ?? "",
        mid: json['MID'] ?? "",
        businessName: json['business_name'] ?? '',
        terminalId: json['terminal_id'] ?? "",
        terminalTapLimit: json['terminal_tap_limit'] ?? 0.0,
        category: json['category'] ?? "",
        tapStatus: json['tap_status'] ?? 0,
      );

  Map<String, dynamic> toJson() => {
        "title": title,
        "device_label": deviceLabel,
        "serialNo": serialNo,
        "card_injection": cardInjection,
        "address": address,
        "master_key": clearMasterKey,
        "pin_key": clearPinKey,
        "business_name": businessName,
        "session_key": clearSessionKey,
        "port": port,
        "ip": ip,
        "mpos_serial": mPosSerial,
        "terminal_id": terminalId,
        "MID": mid,
        "terminal_tap_limit": terminalTapLimit,
        "SN": sn,
        "category": category,
        "tap_status": tapStatus
      };
}
