import 'package:flutter/material.dart';
import 'package:mobile_pos/mobile_pos_sdk.dart';
import 'package:mobile_pos/src/styles/ravenpay_app_colors.dart';

class MobilePOSTheme {
  final Color primaryColor;
  final Color headerTextColor;
  final Color secondaryColor;
  final Color onPrimary;
  final Color lightModeFG;
  final Color darkModeFG;
  final BankBoxThemeMode bankBoxThemeMode;

  // final String? logo;

  const MobilePOSTheme(
      {required this.primaryColor,
      required this.headerTextColor,
      required this.onPrimary,
      required this.lightModeFG,
      required this.darkModeFG,
      this.bankBoxThemeMode = BankBoxThemeMode.light,
      // this.logo,
      required this.secondaryColor});

  factory MobilePOSTheme.defaults() {
    return MobilePOSTheme(
        headerTextColor: AppColors.ravenPayGreen,
        secondaryColor: AppColors.ravenOrangeColor,
        onPrimary: Colors.white,
        lightModeFG: Colors.white,
        darkModeFG: AppColors.darkModeFG,
        // logo: "packages/mobile_pos/assets/images/company_logo.png",
        primaryColor: AppColors.ravenPayGreen);
  }

  bool get isLightTheme => bankBoxThemeMode == BankBoxThemeMode.light;
  Color get getFGColor =>
      bankBoxThemeMode == BankBoxThemeMode.light ? lightModeFG : darkModeFG;
}
