import 'package:flutter/material.dart';
import 'package:mobile_pos/src/helpers/helper_functions.dart';
import 'package:mobile_pos/src/styles/ravenpay_textstyles.dart';

class BankBoxMoneyText extends StatelessWidget {
  const BankBoxMoneyText({
    Key? key,
    required this.amount,
    this.fontWeight = FontWeight.w800,
    this.fontSize = 24,
    this.color,
    this.textAlign = TextAlign.center,
    this.prefixText = '',
    this.suffixText = '',
    this.floorAmount = false,
    this.currencySymbol = '₦',
    this.formatForm,
    this.maskText = false,
  }) : super(key: key);

  final double amount;
  final double fontSize;
  final FontWeight? fontWeight;
  final Color? color;
  final TextAlign textAlign;
  final String? prefixText;
  final String? formatForm;
  final String? suffixText;
  final bool? floorAmount;
  final bool maskText;
  final String currencySymbol;

  @override
  Widget build(BuildContext context) {
    bool toFloor = false;
    if (floorAmount != null) {
      toFloor = floorAmount!;
    }

    return RichText(
      textAlign: textAlign,
      text: TextSpan(
        text: prefixText ?? '',
        style: subtitle.copyWith(
            color: color,
            fontSize: fontSize,
            fontWeight: fontWeight ?? FontWeight.w700),
        children: maskText
            ? [
                TextSpan(
                    text: '********',
                    style: subtitle.copyWith(
                        color: color,
                        fontSize: fontSize,
                        fontWeight: fontWeight ?? FontWeight.w700)),
              ]
            : <TextSpan>[
                TextSpan(
                    text: currencySymbol,
                    style: TextStyle(
                        color: color,
                        fontSize: (fontSize - 3),
                        fontFamily: 'Base-Regular',
                        fontWeight: fontWeight ?? FontWeight.w800)),
                TextSpan(
                    text: (!toFloor)
                        ? currencyNoSymbol(amount)
                        : currencyNoSymbol2(amount, formateForm: formatForm),
                    style: headling1.copyWith(
                        color: color,
                        fontSize: fontSize,
                        fontWeight: fontWeight ?? FontWeight.w800)),
                TextSpan(
                    text: suffixText ?? '',
                    style: subtitle.copyWith(
                        color: color,
                        fontSize: fontSize,
                        fontWeight: fontWeight ?? FontWeight.w800)),
              ],
      ),
    );
  }
}
