import 'package:flutter/material.dart';
import 'package:mobile_pos/src/helpers/global_variables.dart';
import 'package:mobile_pos/src/helpers/helper_functions.dart';
import 'package:mobile_pos/src/models/bankbox_transaction_model.dart';
import 'package:mobile_pos/src/shared_widgets/bankbox_network_image.dart';
import 'package:mobile_pos/src/styles/ravenpay_app_colors.dart';

class BankBoxTransactionIcon extends StatelessWidget {
  final bool showRoundedBorder;
  final Transaction model;
  final double size;
  const BankBoxTransactionIcon(
      {super.key,
      required this.model,
      this.showRoundedBorder = false,
      this.size = 42});

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: [
        Container(
          padding: const EdgeInsets.only(right: 6, bottom: 6),
          decoration: const BoxDecoration(
            shape: BoxShape.circle,
            // color: Colors.red,
          ),
          child: Container(
            decoration: BoxDecoration(
                shape: BoxShape.circle,
                border: showRoundedBorder
                    ? Border.all(
                        color: pluginTheme.isLightTheme
                            ? AppColors.ravenGrey4
                            : AppColors.ravenGrey4.withOpacity(0.1),
                        width: 4)
                    : null),
            height: size,
            width: size,
            child: const ClipOval(
              child: BankBoxNetworkImage(
                url: "",
                // fit: BoxFit.con,
              ),
            ),
          ),
        ),
        if (model.paymentData.responseCode == "00") ...[
          Positioned(
              bottom: 1,
              right: 0,
              child: Container(
                height: 20,
                width: 20,
                padding: const EdgeInsets.all(3),
                decoration: BoxDecoration(
                    shape: BoxShape.circle,
                    border: Border.all(color: Colors.grey.withOpacity(0.1)),
                    color: Colors.white),
                child: Image.asset(loadAsset("credit_icon.png")),
              ))
        ]
      ],
    );
  }
}
