import 'package:calendar_date_picker2/calendar_date_picker2.dart';
import 'package:flutter/material.dart';
import 'package:mobile_pos/src/helpers/global_variables.dart';
import 'package:mobile_pos/src/styles/ravenpay_textstyles.dart';

Future<List<DateTime>?> showBankBoxDateRangePicker(BuildContext context,
    {int maxDays = 90, Color? primaryColor, DateTime? currentDate}) async {
  final size = MediaQuery.of(context).size;
  final now = DateTime.now();
  var results = await showCalendarDatePicker2Dialog(
      dialogBackgroundColor: pluginTheme.getFGColor,
      context: context,
      config: CalendarDatePicker2WithActionButtonsConfig(
          dayTextStyle: subtitle,
          controlsTextStyle: subtitle,
          yearTextStyle: subtitle,
          todayTextStyle: subtitle,
          weekdayLabelTextStyle:
              subtitle.copyWith(fontWeight: FontWeight.w300, fontSize: 10),
          disabledDayTextStyle: subtitle.copyWith(fontWeight: FontWeight.w300),
          calendarType: CalendarDatePicker2Type.range,
          currentDate: currentDate,
          firstDate: now.subtract(Duration(days: maxDays)),
          lastDate: now),
      dialogSize: Size(size.width * .8, size.height / 2),
      borderRadius: BorderRadius.circular(15),
      value: []);

  if (results == null) {
    return null;
  } else if (results.length < 2) {
    return null;
  } else {
    return [results[0]!, results[1]!];
  }
}
