import 'package:flutter/material.dart';
import 'package:gap/gap.dart';
import 'package:mobile_pos/src/helpers/global_variables.dart';
import 'package:mobile_pos/src/helpers/helper_functions.dart';
import 'package:mobile_pos/src/styles/ravenpay_textstyles.dart';

class BankBoxEmptyState extends StatelessWidget {
  final String statement;
  final String asset;
  const BankBoxEmptyState(
      {super.key, required this.statement, this.asset = "empty_tranx_icon"});

  @override
  Widget build(BuildContext context) {
    Size size = MediaQuery.of(context).size;
    return Padding(
      padding: EdgeInsets.symmetric(horizontal: kHorizontalScreenPadding),
      child: Column(
        mainAxisAlignment: MainAxisAlignment.center,
        children: [
          Image.asset(
            loadAsset("$asset.png"),
            height: size.width * 0.35,
          ),
          const Gap(24),
          Text(
            statement,
            textAlign: TextAlign.center,
            style: subtitle,
          ),
          const Gap(24)
        ],
      ),
    );
  }
}
