import 'package:flutter/material.dart';
import 'package:mobile_pos/src/helpers/global_variables.dart';
import 'package:mobile_pos/src/styles/ravenpay_app_colors.dart';

class RavenPayCard extends StatelessWidget {
  final Widget child;
  final EdgeInsets? padding;
  final double? height;
  const RavenPayCard(
      {super.key, this.padding, this.height, required this.child});

  @override
  Widget build(BuildContext context) {
    return Container(
        padding:
            padding ?? const EdgeInsets.symmetric(horizontal: 4, vertical: 12),
        height: height,
        width: double.infinity,
        decoration: BoxDecoration(
            borderRadius: BorderRadius.circular(18),
            border: Border.all(
                color: pluginTheme.isLightTheme
                    ? AppColors.ravenPayGrey2
                    : AppColors.ravenPayGrey2.withOpacity(0.4),
                width: pluginTheme.isLightTheme ? 0.5 : 1)),
        child: child);
  }
}
