import 'package:confetti/confetti.dart';
import 'package:flutter/material.dart';

class BankBoxCoffetti extends StatefulWidget {
  const BankBoxCoffetti({
    super.key,
  });

  @override
  State<BankBoxCoffetti> createState() => _BankBoxCoffettiState();
}

class _BankBoxCoffettiState extends State<BankBoxCoffetti> {
  late ConfettiController _confettiController;

  @override
  void initState() {
    _confettiController =
        ConfettiController(duration: const Duration(seconds: 5));
    super.initState();
    _confettiController.play();
  }

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: [
        Align(
          alignment: Alignment.topCenter,
          child: ConfettiWidget(
            confettiController: _confettiController,
            blastDirectionality: BlastDirectionality
                .explosive, // don't specify a direction, blast randomly
            shouldLoop:
                false, // start again as soon as the animation is finished
            colors: const [
              Colors.purple,
              Colors.orange,
              Colors.green
            ], // manually specify the colors to be used
            // createParticlePath:
            //     HelperFunctions.drawConfetti,
            // define a custom shape/path.
            maximumSize: const Size(11, 6),
            minimumSize: const Size(10, 5),
          ),
        ),
      ],
    );
  }
}
