import 'package:flutter/material.dart';
import 'package:gap/gap.dart';
import 'package:mobile_pos/src/helpers/global_variables.dart';
import 'package:mobile_pos/src/styles/ravenpay_app_colors.dart';
import 'package:mobile_pos/src/styles/ravenpay_textstyles.dart';
import 'package:mobile_pos/src/views/terminal/widget/termianl_settings.dart';

class SuccessItemWidget extends StatelessWidget {
  final String title;
  final String value;
  final bool showDivider;
  const SuccessItemWidget(
      {super.key,
      required this.title,
      required this.value,
      this.showDivider = true});

  @override
  Widget build(BuildContext context) {
    return Column(
      children: [
        const Gap(14),
        Row(
          children: [
            Text(title, style: subtitle.copyWith(fontWeight: FontWeight.w500, fontSize: 14)),
            const Gap(16),
            Expanded(
              child: Text(
                value,
                style: subtitle.copyWith(
                  fontSize: 14,
                  fontWeight: FontWeight.w500,
                    color: pluginTheme.isLightTheme
                        ? AppColors.ravenPayDark
                        : Colors.white),
                textAlign: TextAlign.end,
              ),
            )
          ],
        ),
        const Gap(12),
        if (showDivider) ...[
          const BankBoxDivider(
            height: 10,
          )
        ]
      ],
    );
  }
}
