import 'package:flutter/material.dart';
import 'package:gap/gap.dart';
import 'package:mobile_pos/src/helpers/global_variables.dart';
import 'package:mobile_pos/src/styles/ravenpay_textstyles.dart';

class BankBoxStep extends StatelessWidget {
  final int step;
  const BankBoxStep({super.key, this.step = 1});

  @override
  Widget build(BuildContext context) {
    return Row(
      children: [
        Container(
            height: 21,
            alignment: Alignment.center,
            width: 21,
            decoration: BoxDecoration(
                shape: BoxShape.circle,
                color: pluginConfig.theme!.primaryColor),
            child: Text(step.toString(),
                style: bodyText.copyWith(color: Colors.white, fontSize: 12))),
        const Gap(8),
        RichText(
            text: TextSpan(
                text: "STEP ",
                style: headling1.copyWith(
                    fontSize: 14, fontWeight: FontWeight.w500),
                children: [
              TextSpan(
                  text: step.toString(),
                  style: subtitle.copyWith(
                      fontWeight: FontWeight.w600, fontSize: 14)),
              TextSpan(
                  text: "/2",
                  style: subtitle.copyWith(
                      fontWeight: FontWeight.w600,
                      color: pluginConfig.theme!.primaryColor,
                      fontSize: 14))
            ]))
      ],
    );
  }
}
